﻿#define  _USE_MATH_DEFINES

#include <stdio.h>
#include <math.h>

// Degree to Radian
//#define DEGREE_RADIAN(_deg) (M_PI*(_deg)/180.0f)
#define DEGREE_RADIAN(_deg) ((_deg)*M_PI/180.0f)

// Radian to Degree
#define RADIAN_DEGREE(_rad) ((_rad)*180.0f/M_PI)


int main()
{

	double rad_d = DEGREE_RADIAN(45.0);

	double sin_d = sin(rad_d);
	double cos_d = cos(rad_d);
	double tan_d = tan(rad_d);

	double  asin_d = asin(0.5);
	double  acos_d = acos(0.5);
	double  atan_d = atan(0.5);

	// atan2는 물체 사이 공간을 파악하는데 사용한다. 그리고 인자로 밑변과 대변을 필요로 한다.
	// 결과 범위 (-180 ~ 180)
	double atan2_d = atan2(2.0f, 1.0f);

	printf("sin 45 (double) : %f\n", sin_d);
	printf("cos 45 (double) : %f\n", cos_d);
	printf("tan 45 (double) : %f\n", tan_d);
	printf("\n");
	printf("asin 0.5 (dobule) : %f(radian)  %f(degree)\n", asin_d, RADIAN_DEGREE( asin_d ));
	printf("acos 0.5 (dobule) : %f(radian)  %f(degree)\n", acos_d, RADIAN_DEGREE( acos_d ));
	printf("atan 0.5 (dobule) : %f(radian)  %f(degree)\n", atan_d, RADIAN_DEGREE( atan_d ));
	printf("\n");
	printf("atan2 2.0,1.0 (dobule) : %f(radian)  %f(degree)\n", atan2_d, RADIAN_DEGREE(atan2_d));

	return 0;

}